"======================================================================
|
|   Compute the amount of memory and the number of instances for each
|   class in the GNU Smalltalk system.
|
|
 ======================================================================"

 
"======================================================================
|
| Copyright 1988-92, 1994-95, 1999, 2000 Free Software Foundation, Inc.
| Written by Steve Byrne.
|
| This file is part of GNU Smalltalk.
|
| GNU Smalltalk is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 2, or (at your option) any later version.
| 
| GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| GNU Smalltalk; see the file LICENSE.  If not, write to the Free Software
| Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
|
 ======================================================================"


!Behavior methodsFor: 'demo'!

showMemUsage
    | t numObjs classObjs totalInstanceSize instVarSize |
    numObjs := t := 0.
    ObjectMemory compact.
    Object withAllSubclasses do: 
	[ :class | "class printNl."
		   totalInstanceSize := classObjs := 0.
		   instVarSize := class instSize.
    	    	   (class inheritsFrom: ContextPart)
		       ifFalse: [ class allInstancesDo:
				      [ :inst | totalInstanceSize := totalInstanceSize +
						    ((WordMemory at: (ObjectMemory addressOf: inst)) * 4).
						classObjs := classObjs + 1 ] 
				      ].
						    
		   "Transcript nextPutAll: '  Instances: '. classObjs printNl.
		   Transcript nextPutAll: '  Size: '. totalInstanceSize printNl.
		   Transcript nl."
		   t := t + totalInstanceSize.
		   numObjs := numObjs + classObjs ].

    numObjs printNl.
    t printNl
! !

Object showMemUsage!
